## relacy 0.0+git20191025.acc09bb

=== Makefile ===
# User-customizable variables:
CXX ?= c++
CXXFLAGS ?=
DEPFLAGS ?= -MD -MF $(@).d -MP -MT $(@)
build_dir = build

.SECONDARY:

example_programs = cli_ws_deque
test_programs = ntest/ntest

example_exe_files = $(foreach name,$(example_programs),$(build_dir)/example/$(name)/$(name))
test_exe_files = $(foreach name,$(test_programs),$(build_dir)/test/$(name))

exe_files = $(example_exe_files) $(test_exe_files)
o_files = $(exe_files:=.cpp.o)

ansi_term_csi = [
ansi_term_bold = $(ansi_term_csi)1m
ansi_term_green = $(ansi_term_csi)32m
ansi_term_red = $(ansi_term_csi)31m
ansi_term_reset = $(ansi_term_csi)m

COMPILE.cpp = $(CXX) $(DEPFLAGS) $(CXXFLAGS) -c
LINK.cpp = $(CXX) $(CXXFLAGS)

.PHONY: all
all: examples tests

.PHONY: examples tests
examples: $(example_exe_files)
tests: $(test_exe_files)

.PHONY: check
check: check-examples check-tests

.PHONY: check-examples check-tests
check-examples: $(example_exe_files:=.check-result)
check-tests: $(test_exe_files:=.check-result)

$(build_dir)/%.check-result: $(build_dir)/% always-run
	@ \
	printf '%s%s ...%s\n' $(ansi_term_bold) $(*) $(ansi_term_reset) >&2; \
	$(<); \
	status="$${?}"; \
	printf %d "$${status}" >$(@); \
	if [ "$${status}" -eq 0 ]; then \
		printf '%s%s %s%s\n' $(ansi_term_green) $(*) OK $(ansi_term_reset); \
	else \
		printf '%s%s %s%s\n' $(ansi_term_red) $(*) FAIL $(ansi_term_reset); \
	fi >&2; \
	exit "$${status}"

$(build_dir)/%: $(build_dir)/%.cpp.o
	$(LINK.cpp) $(^) -o $(@)

$(build_dir)/%.cpp.o: %.cpp
	@mkdir -p $(dir $(@))
	$(COMPILE.cpp) -o $(@) $(<)

.PHONY: clean
clean:
	rm -fr -- $(build_dir)/

.PHONY: always-run
always-run:

-include $(o_files:=.d)

=== debian/changelog ===
relacy (0.0+git20191025.acc09bb-2) unstable; urgency=medium

  * Team upload.

 -- Andreas Tille <tille@debian.org>  Thu, 06 Aug 2020 17:23:18 +0200

relacy (0.0+git20191025.acc09bb-1) unstable; urgency=medium

  * Initial release (Closes: #966204)

 -- Shayan Doust <hello@shayandoust.me>  Sat, 25 Jul 2020 19:19:20 +0000

=== debian/control ===
Source: relacy
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Shayan Doust <hello@shayandoust.me>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13)
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/med-team/relacy
Vcs-Git: https://salsa.debian.org/med-team/relacy.git
Homepage: https://github.com/dvyukov/relacy
Rules-Requires-Root: no

Package: relacy-dev
Architecture: all
Multi-Arch: foreign
Section: libdevel
Depends: ${misc:Depends}
Description: meticulous synchronization algorithm verifier for relaxed memory models
 Relacy Race Detector is a tool for efficient execution of unit tests for
 synchronization algorithms written in C++0x. Every user thread is
 represented as a fiber (ucontext). Every time only one fiber is running,
 and special scheduler controls interleaving between fibers. With random
 scheduler it just executes numerous amount of various interleavings
 between threads. With full search scheduler or context-bound scheduler
 it systematically executes all possible interleavings between threads.
 While executing particular interleaving it makes exhaustive verification
 of various aspects of execution (races, accesses to freed memory etc).
 .
 If no errors found then verification terminates when particular number
 of interleavings are verified (for random scheduler), or when all
 possible interleavings are verified (for full search scheduler). If
 error is found then tool outputs execution history which leads to error
 and terminates. Physically Relacy Race Detector is a header-only library
 for C++98.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1
export LC_ALL=C.UTF-8

include /usr/share/dpkg/default.mk

# for hardening you might like to uncomment this:
# export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	$(MAKE) check-tests
	$(MAKE) check-examples
endif

=== debian/watch ===
version=4

opts="mode=git,pretty=0.0+git%cd.%h" \
  https://github.com/dvyukov/relacy.git HEAD
